unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Button1: TButton;
    Edit1: TEdit;
    OpenDialog1: TOpenDialog;
    Label1: TLabel;
    Button2: TButton;
    Button3: TButton;
    SaveDialog1: TSaveDialog;
    Image1: TImage;
    ColorDialog1: TColorDialog;
    Panel1: TPanel;
    Button4: TButton;
    Panel2: TPanel;
    Button5: TButton;
    Button6: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Panel3: TPanel;
    Panel4: TPanel;
    Edit2: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Button7: TButton;
    SaveDialog2: TSaveDialog;
    CheckBox1: TCheckBox;
    Label10: TLabel;
    Label11: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Image1_Mouseover(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Image1_RightClick(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure Button7Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  coordfile, coordfile_second, newcoordfile: Text;
  s, s1, s2, seqmaxX, seqmaxY: String;
  second, drawn, weitere1, weitere2: Boolean;
  i, j, k, l, zoom: Integer;
  farbe: TColor;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
 ScrollBox1.Height := Form1.Height-100;
 zoom := 1;
 Colordialog1.Color := clRed;
 ScrollBox1.VertScrollBar.Position := ScrollBox1.VertScrollBar.Range; {zurck nach unten scrollen}
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 Opendialog1.Filter := 'Koordinatendatei (*.cor)|*.COR';
 Opendialog1.Execute;
 Edit1.Text:=Opendialog1.Filename;
 drawn := false;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 Savedialog1.Filter := 'Windows-Bitmap (*.bmp)|*.BMP';
 Savedialog1.Execute;
 if Savedialog1.Filename[length(Savedialog1.Filename)-3]+Savedialog1.Filename[length(Savedialog1.Filename)-2]+Savedialog1.Filename[length(Savedialog1.Filename)-1]+Savedialog1.Filename[length(Savedialog1.Filename)]<>'.bmp'
  then Savedialog1.Filename := Savedialog1.Filename+'.bmp';
 Image1.Picture.Graphic.SaveToFile(Savedialog1.Filename);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 if (Edit1.Text='') or (Edit1.Text='<Koordinatendatei>') then Application.Messagebox('Es wurde keine Quelldatei angegeben', 'Fehler', 48+0)
  else
   begin
    Assignfile(coordfile, Edit1.Text);
    Reset(coordfile);
    Readln(coordfile, seqmaxX);  {Gesamtlnge der X-Sequenz auslesen und als Maximalwert setzen}
    Readln(coordfile, seqmaxY);

    zoom := 1;
    Button5.Caption := 'zoom in ('+IntToStr(zoom)+':1)';
    Button6.Caption := 'zoom out ('+IntToStr(zoom)+':1)';

    ScrollBox1.VertScrollBar.Position := 0;
    ScrollBox1.HorzScrollBar.Position := 0;
    Image1.Width := StrToInt(seqmaxX)*zoom;
    Image1.Height := StrToInt(seqmaxY)*zoom;
    Image1.Picture.Graphic.Width:=StrToInt(seqmaxX);
    Image1.Picture.Graphic.Height:=StrToInt(seqmaxY);
     {die Breite der eigentlichen Grafik ist fest, die des Image-Objektes aber nicht -> einfaches Zoomen per Stretch-Funktion}
    ScrollBox1.VertScrollBar.Position := ScrollBox1.VertScrollBar.Range; {zurck nach unten scrollen}
    Repeat
     Readln(coordfile, s);
     s1:=''; s2:=''; second := false;
     For i:=1 to length(s) do
      begin
       if (second=false) and (s[i]<>',') then s1:=s1+s[i];
       if s[i]=',' then second:=true;
       if (second=true) and (s[i]<>',') then s2:=s2+s[i];
      end;
     if Image1.Canvas.Pixels[StrToInt(s1)-1, StrToInt(seqmaxY)-StrToInt(s2)]=clWhite
      then Image1.Canvas.Pixels[StrToInt(s1)-1, StrToInt(seqmaxY)-StrToInt(s2)] := Colordialog1.Color
       else Image1.Canvas.Pixels[StrToInt(s1)-1, StrToInt(seqmaxY)-StrToInt(s2)] := Colordialog1.Color+Image1.Canvas.Pixels[StrToInt(s1)-1, StrToInt(seqmaxY)-StrToInt(s2)];

    Until EOF(coordfile);
    Closefile(coordfile);
    drawn := true;
   end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 if Image1.Picture.Graphic.Width<>0 then Image1.Picture.Graphic.Width:=0;
 if Image1.Picture.Graphic.Height<>0 then Image1.Picture.Graphic.Height:=0;
 Image1.Repaint;
 drawn := false;
 ScrollBox1.VertScrollBar.Position := ScrollBox1.VertScrollBar.Range; {zurck nach unten scrollen}
end;

procedure TForm1.Panel1Click(Sender: TObject);
begin
 Colordialog1.Execute;
 Panel1.Color := Colordialog1.Color;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 if drawn=true then
  begin
   zoom := zoom+1;
   ScrollBox1.VertScrollBar.Position := 0;
   ScrollBox1.HorzScrollBar.Position := 0;
   Image1.Width := StrToInt(seqmaxX)*zoom;
   Image1.Height := StrToInt(seqmaxY)*zoom;
   ScrollBox1.VertScrollBar.Position := ScrollBox1.VertScrollBar.Range; {zurck nach unten scrollen}
   Button5.Caption := 'zoom in ('+IntToStr(zoom)+':1)';
   Button6.Caption := 'zoom out ('+IntToStr(zoom)+':1)';
  end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
 if drawn=true then
  begin
   if zoom>0 then
    begin
     zoom := zoom-1;
     ScrollBox1.VertScrollBar.Position := 0;
     ScrollBox1.HorzScrollBar.Position := 0;
     if zoom>0 then
      begin
       Button5.Caption := 'zoom in ('+IntToStr(zoom)+':1)';
       Button6.Caption := 'zoom out ('+IntToStr(zoom)+':1)';
       Image1.Width := StrToInt(seqmaxX)*zoom;
       Image1.Height := StrToInt(seqmaxY)*zoom;
      end
     else if zoom=0 then
      begin
       Button5.Caption := 'zoom in (0,5:1)';
       Button6.Caption := 'zoom out (0,5:1)';
       Image1.Width := (StrToInt(seqmaxX) div 2);
       Image1.Height := (StrToInt(seqmaxY) div 2);
      end;
     ScrollBox1.VertScrollBar.Position := ScrollBox1.VertScrollBar.Range;
   end;
  end;
end;

procedure TForm1.Image1_Mouseover(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
 if zoom>0 then
  begin
   Label2.Caption := IntToStr((X div zoom)+1);
   Label3.Caption := IntToStr(((Image1.Height-Y+1) div zoom));
  end
 else if zoom=0 then
  begin
   Label2.Caption := IntToStr(((X)*2)+1);
   Label3.Caption := IntToStr(((Image1.Height-Y+1)*2));
  end;
end;

procedure TForm1.Image1_RightClick(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
 Button6.Click;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
 if drawn=false then Application.Messagebox('Sie mssen zuerst eine Graphik zeichen lassen', 'Fehler', 48+0)
  else if Edit2.Text='' then Application.Messagebox('Bitte geben Sie eine bereinstimmungslnge ein', 'Fehler', 48+0)
   else
    begin
     if Application.MessageBox('Sind Sie sicher? Das knnte etwas Zeit in Anspruch nehmen', 'Achtung', 32+1)=1
      then begin
            if zoom<>1 then if zoom=0 then Button5.Click
                             else Repeat
                                   Button6.Click;
                                  Until zoom=1;
            For i:=0 to Image1.Picture.Graphic.Width do
             For j:=0 to Image1.Picture.Graphic.Height do
               if Image1.Canvas.Pixels[i,j]<>clwhite
                then begin
                      farbe:=Image1.Canvas.Pixels[i,j];
                      weitere1:=true; weitere2:=true; k:=1; l:=1;
                      While (weitere1=true) and (k<StrToInt(Edit2.Text)) do
                       begin
                        if (CheckBox1.Checked=false) and (Image1.Canvas.Pixels[i+k,j-k]<>farbe) then weitere1:=false
                         else if (CheckBox1.Checked=true) and (Image1.Canvas.Pixels[i+k,j-k]<>farbe)
                            and (Image1.Canvas.Pixels[i+k+1,j-k]<>farbe) and (Image1.Canvas.Pixels[i+k,j-k-1]<>farbe)
                            and (Image1.Canvas.Pixels[i+k+1,j-k-1]<>farbe) then weitere1:=false
                          else k:=k+1;
                        end;
                      if k<StrToInt(Edit2.Text) then
                       begin
                        While (weitere2=true) and ((l+k-1)<StrToInt(Edit2.Text)) do
                         begin
                        if (CheckBox1.Checked=false) and (Image1.Canvas.Pixels[i-l,j+l]<>farbe) then weitere2:=false
                         else if (CheckBox1.Checked=true) and (Image1.Canvas.Pixels[i-l,j+l]<>farbe)
                            and (Image1.Canvas.Pixels[i-l-1,j+l]<>farbe) and (Image1.Canvas.Pixels[i-l,j+l+1]<>farbe)
                            and (Image1.Canvas.Pixels[i-l-1,j+l+1]<>farbe) then weitere2:=false
                          else l:=l+1;
                         end;
                        k:=k+l-1;
                       end;
                      if k<StrToInt(Edit2.Text) {wenn k immernoch nicht gro genug}
                       then Image1.Canvas.Pixels[i,j]:=clwhite; {lschen}
                     end;
            if Application.MessageBox('Mchten Sie das Ergebnis in eine Koordinatendatei abspeichern?', 'Frage', 32+4)=6
             then begin
                   Savedialog2.Filter := 'Koordinatendatei (*.cor)|*.COR';
                   Savedialog2.Execute;
                   if Savedialog2.Filename[length(Savedialog2.Filename)-3]+Savedialog2.Filename[length(Savedialog2.Filename)-2]+Savedialog2.Filename[length(Savedialog2.Filename)-1]+Savedialog2.Filename[length(Savedialog2.Filename)]<>'.cor'
                    then Savedialog2.Filename := Savedialog2.Filename+'.cor';

                   Assignfile(newcoordfile, Savedialog2.Filename);
                   Rewrite(newcoordfile);
                   Writeln(newcoordfile, seqmaxX);
                   Writeln(newcoordfile, seqmaxY);
                   For i:=0 to Image1.Width-1 do
                    For j:=0 to Image1.Height-1 do
                     if Image1.Canvas.Pixels[i,j]<>clWhite then
                       Writeln(newcoordfile, IntToStr(i+1)+','+IntToStr(Image1.Height-j));
                   Closefile(newcoordfile);
                  end;

           end;
    end;
end;

end.
